<?php
/** 
* @desc this program will add or edit a logaholic user account
* for more information please read:
* http://www.logaholic.com/manual/LogaholicManual/APIDocumentationForServiceProviderEditions  
*/

class LogaholicDBSubscription {
	var $subscriptionid;
	var $subscriptionname;
	var $subscriptionvalues;
	
	#Delete vars
	var $movetosubid;
	var $movetosubname;
	
	function __construct(){
		$this->subscriptionname = '';
		$this->subscriptionid = '';
		$this->subscriptionvalues = '';
		
		$this->movetosubid = '';
		$this->movetosubname = '';
		
		# first check the variables we need to execute this program
        $this->CheckVars();
        
        # now connect to the database
        $this->dbConnect();
	}
	
	function CheckVars(){
        global $action;
		$help = "Required at least one of these variables:<br>\n";
        $help .= " - subscriptionname (addsubscription, editsubscription, deletesubscription)<br>\n";
        $help .= " - subscriptionid (editsubscription, deletesubscription)<br>\n";
		$help .= "Optional variables:<br>\n";
        $help .= " - movetosubid (deletesubscription)<br>\n";
        $help .= " - movetosubname (deletesubscription)<br>\n";
		$help .= "- Your custom variables (example: Price=&description=)<br>\n";
		
		
		if(empty($_GET["subscriptionname"]) && empty($_GET["subscriptionid"])){
			echo $help;
			exit;
		}
		if(empty($_GET["subscriptionname"]) && $action = "addsubscription"){
			echo $help;
			exit;
		}
		
		if(!empty($_GET["movetosubid"])){
			$this->movetosubid = $_GET["movetosubid"];
		}
		
		if(!empty($_GET["movetosubname"])){
			$this->movetosubname = $_GET["movetosubname"];
		}
		
		
		if(!empty($_GET["subscriptionname"])){
			$this->subscriptionname = $_GET["subscriptionname"];
		}
		if(!empty($_GET["subscriptionid"])){
			$this->subscriptionid = $_GET["subscriptionid"];
		}
		
		$this->SetValues();
		
	}
	
	function SetValues(){
		global $action;
		$values = array();
		$ignore = array(
			"subscriptionname"
			,"subscriptionid"
			,"action"
			,"api_password"
			,"movetosubid"
			,"movetosubname"
		);
		
		foreach($_GET as $rkey => $rval){
			if(!in_array($rkey,$ignore)){
				$values[$rkey]['value'] = $rval;
				$values[$rkey]['type'] = '';			
			}
		}
		$this->subscriptionvalues = serialize($values);
	}
	
	function dbConnect() {
        global $db, $config;
        
        require_once($config['path']."/files/global.php");
        require_once($config['path']."/components/adodb/adodb-errorhandler.inc.php");  
        require_once($config['path']."/components/adodb/adodb.inc.php");
                
        if (function_exists("mysqli_connect")) {
            $db = ADONewConnection("mysqli");
        } else {
            $db = ADONewConnection("mysql");
        }        
        @$db->Connect($mysqlserver,$mysqluname,$mysqlpw,$DatabaseName) or die("An error occurred: ".$db->ErrorMsg());
            
    }
	
	function AddSubscription(){
		global $db;
		
		$query = "INSERT INTO `_logaholic_subscriptions` (`name`,`value`) VALUES (". $db->quote($this->subscriptionname).",". $db->quote($this->subscriptionvalues).")";
		
		@$db->Execute($query) or die("An error occurred ". $db->ErrorMsg());
        
		echo "Success: Added subscription $this->subscriptionname<br>\n";
	}
	
	function EditSubscription(){
		global $db;
		if(empty($this->subscriptionid)){
			$q = $db->Execute("SELECT `id`,`value` FROM `_logaholic_subscriptions` WHERE `name` =". $db->quote($this->subscriptionname) ." limit 1");
			$data = $q->fetchRow();
			$id = $data['id'];
			$values = unserialize($data['value']);
		} else {
			$id = $this->subscriptionid;
			$q = $db->Execute("SELECT `value` FROM `_logaholic_subscriptions` WHERE `id` = {$id}");
			$data = $q->fetchRow();
			$values = unserialize($data['value']);
			
		}
		
		
		# do i want to edit the name?
		$editname = "";
		if(!empty($this->subscriptionid) && !empty($this->subscriptionname)){
			$editname = ", `name`= ". $db->quote($this->subscriptionname) ." ";
		}
		
		
		# values		
		$this->subscriptionvalues = unserialize($this->subscriptionvalues);
		foreach($this->subscriptionvalues as $k => $v){
			$values[$k] = $v;
		}
		
		# do the edit query
		$values = serialize($values);
		$query = "UPDATE `_logaholic_subscriptions` SET `value` =". $db->quote($values) ." {$editname} WHERE `id` = {$id} ";
		
        @$db->Execute($query) or die("An error occurred ". $db->ErrorMsg());
        
        echo "Success: Edited subscription $this->subscriptionname<br>\n";    
	}
	
	function DeleteSubscription(){
		global $db;
		if(empty($this->subscriptionid)){
			$q = $db->Execute("SELECT `id` FROM `_logaholic_subscriptions` WHERE `name` =". $db->quote($this->subscriptionname) ." limit 1");
			$data = $q->fetchRow();
			$id = $data['id'];
		} else {
			$id = $this->subscriptionid;
		}
		
		$setid = 'null';
		if(!empty($this->movetosubid)){
			$setid = $this->movetosubid;
		}
		else if(!empty($this->movetosubname)){
			$q = $db->Execute("SELECT `id` FROM `_logaholic_subscriptions` WHERE `name` =". $db->quote($this->movetosubname) ." LIMIT 1");
			$data = $q->fetchRow();
			$id = $data['id'];
		}
		
		
		@$db->Execute("UPDATE `_logaholic_users` SET subscriptionid = {$setid} WHERE `subscriptionid` = {$id}");
		
		# finally, delete the user record
        @$db->Execute("delete from `_logaholic_subscriptions` where `name`=\"$this->subscriptionname\"") or die("An error occurred:" .$db->ErrorMsg());
        
        echo "Success: Deleted subscription $this->subscriptionname<br>\n";  
		
	}
	

}
?>