<?php
/** 
* @desc this program will add or edit a logaholic user account
* for more information please read:
* http://www.logaholic.com/manual/LogaholicManual/APIDocumentationForServiceProviderEditions  
*/

class LogaholicDBUser {
    
    var $logaholicuser;
    var $logaholicpass;
    var $logaholicname;
    var $logaholicemail;
    var $logaholic_newusername; // when editing a user, a new_username must be supplied (may be the same as the old username)
	var $usersubscriptionid;
    var $accessEditProfile;
    var $accessAddProfile;
    var $accessUpdateLogs;
    var $active;
    var $expires;
    
    # this will run when the program starts
    function __construct() {
        global $db;
        
        #set some default values
        $this->accessEditProfile = "1";
        $this->accessAddProfile = "0";
        $this->accessUpdateLogs = "0";
        $this->active = "1";
        $this->expires = "0";     
		$this->usersubscriptionid = 0;   
        
        # first check the variables we need to execute this program
        $this->CheckVars();
        
        # now connect to the database
        $this->dbConnect();
          
        return;            
    }
    
    function LogaholicDBUser() {
        __construct();
    }
    
    
    /**
    * @desc This function checks the required variables
    */
    function CheckVars() {
        global $action;
        
        $help = "Required variables:<br>\n";
        $help.= " - username (adduser, edituser, deleteuser, getdbsize)<br>\n";
        $help.= " - password (adduser, edituser)<br>\n";
        $help.= " - new_username (edituser) <br><br>\n\n"; 
        $help .= "Optional variables:<br>\n";
        $help.= " - fullname <br>\n";
        $help.= " - email <br>\n";
        $help.= " - accessEditProfile <br>\n";
        $help.= " - accessAddProfile <br>\n";
        $help.= " - accessUpdateLogs <br>\n";
        $help.= " - active <br>\n";
        $help.= " - expires <br>\n";
        $help.= " - subscriptionid (The id of the subscription. NOT the name.) <br>\n";
        
        if ($action=="deleteuser") {
            if (!empty($_GET["username"])) {
                $this->logaholicuser = $_GET["username"];
                return;    
            }    
        }
        
        if ($action=="listuserprofiles") {
            if (!empty($_GET["username"])) {
                $this->logaholicuser = $_GET["username"];
                return;    
            }    
        }
        
        if ($action=="edituser") {
            if (empty($_GET["new_username"])) {
                echo "When editing users, variable new_username is required <br><br>\n\n";
                echo $help;
                exit();    
            }    
        }
        
        if ($action=='fetchuser') {
            if (!empty($_GET['username'])) {
                $this->logaholicuser = $_GET["username"];
                return;
            }
        }
		
		if ($action=='getdbsize') {
            if (!empty($_GET['username'])) {
                $this->logaholicuser = $_GET["username"];
                return;
            }
        }
		
        if (isset($_GET["username"])) {
            $this->logaholicuser = $_GET["username"];
            if (isset($_GET['password'])) {
            $this->logaholicpass = $_GET["password"];
            }
            if (isset($_GET['fullname'])) {
                $this->logaholicname = $_GET["fullname"];
            }
            if (isset($_GET['email'])) {
                $this->logaholicemail = $_GET["email"];
            }
            if (isset($_GET['new_username'])) {
                $this->logaholic_newusername = $_GET["new_username"];
            }
            if (isset($_GET["accessEditProfile"])) {
                $this->accessEditProfile = $_GET["accessEditProfile"];    
            }
            if (isset($_GET["accessAddProfile"])) {
                $this->accessAddProfile = $_GET["accessAddProfile"];    
            }
            if (isset($_GET["accessUpdateLogs"])) {
                $this->accessUpdateLogs = $_GET["accessUpdateLogs"];    
            }
            if (isset($_GET["active"])) {
                $this->active = $_GET["active"];    
            }
            if (isset($_GET["expires"])) {
                $this->expires = $_GET["expires"];    
            }
			if (isset($_GET["subscriptionid"])) {
                $this->usersubscriptionid = $_GET["subscriptionid"];    
            }
			
            if ( (!empty($this->logaholicpass) && !empty($this->logaholicuser))
              || ($action == 'edituser' && !empty($this->logaholicuser))
            ) {
                return;    
            } else {
                echo "We need a valid username and password <br><br>\n\n";
                echo $help;             
                exit();
            }
        } else {
            echo $help;
            exit();
        }        
    }
    
    function dbConnect() {
        global $db, $config;
        
        require_once($config['path']."/files/global.php");
        require_once($config['path']."/components/adodb/adodb-errorhandler.inc.php");  
        require_once($config['path']."/components/adodb/adodb.inc.php");
                
        if (function_exists("mysqli_connect")) {
            $db = ADONewConnection("mysqli");
        } else {
            $db = ADONewConnection("mysql");
        }        
        @$db->Connect($mysqlserver,$mysqluname,$mysqlpw,$DatabaseName) or die("An error occurred: ".$db->ErrorMsg());
            
    }
    
    /**
    * @desc This function will add the user to the user table
    */    
    function AddUser() {
        global $db;          
        
        $query = "INSERT INTO `_logaholic_users` (username, name, password, email, created, isAdmin, active, accessUpdateLogs, accessAddProfile, accessEditProfile, expires, subscriptionid ) ".
                 "VALUES (\"".$this->logaholicuser."\", \"".$this->logaholicname."\", \"".$this->logaholicpass."\", \"".$this->logaholicemail."\", UNIX_TIMESTAMP(NOW()), 0,$this->active,$this->accessUpdateLogs,$this->accessAddProfile,$this->accessEditProfile,$this->expires,$this->usersubscriptionid)";        
	echo "<br/>".$query;
	   @$db->Execute($query) or die("An error occurred: ". $db->ErrorMsg());
        
        echo "Success: Added user $this->logaholicuser<br>\n";
    }
    
    /**
    * @desc This function will edit an existing user
    */
    function EditUser() {
        global $db;
        
        $query = "UPDATE `_logaholic_users` SET username=\"".$this->logaholic_newusername."\"";
        
        /**
         *  if these values are null, the they were never passed in the request
         *  so don't attempt to update them: it could nullify an existing value
         */
        if ($this->logaholicpass !== null) {
            $query .=", password=\"".$this->logaholicpass."\"";
        }
        
        if ($this->logaholicname !== null) {
            $query .=", name=\"".$this->logaholicname."\"";
        }
        
        if ($this->logaholicemail !== null) { 
            $query .=", email=\"".$this->logaholicemail."\"";
        }

        if ($this->accessUpdateLogs !== null) {
            $query .=", accessUpdateLogs=\"$this->accessUpdateLogs\"";
        }
        
        if ($this->accessAddProfile !== null) {
            $query .=", accessAddProfile=\"$this->accessAddProfile\"";
        }
        
        if ($this->accessEditProfile !== null) {
            $query .=", accessEditProfile=\"$this->accessEditProfile\"";
        }
        
        if ($this->usersubscriptionid !== null) {
            $query .=", subscriptionid=\"$this->usersubscriptionid\"";
        }
		
        $query .= " where username=\"".$this->logaholicuser."\"";
        @$db->Execute($query) or die("An error occurred ". $db->ErrorMsg());
        
        echo "Success: Edited User $this->logaholic_newusername<br>\n";        
    }
    
    /**
    * @desc This function will delete a user and all profiles that belong to that user
    */
    function DeleteUser() {
        global $db;
        
        # first, get the list of profiles for this user
        $profile_list = getProfileList($this->logaholicuser);
        
        # next, delete each profile from the system
        if (!empty($profile_list)) {
            $profiles = explode(",",$profile_list);         
            foreach($profiles as $profile) {
                # do the delete action using the LogaholicDBprofile class    
                $_GET['site'] = $this->getSiteFromProfilename($profile);
                $site = new LogaholicDBProfile();
                $site->profile_name = $profile;
                $site->DeleteProfile();
            }
        }       
        
        # finally, delete the user record
        @$db->Execute("delete from `_logaholic_users` where username=\"$this->logaholicuser\" limit 1") or die("An error occurred:" .$db->ErrorMsg());
        
        echo "Success: Deleted user $this->logaholicuser<br>\n";            
    }
    
    function FetchUser() {
        global $db;
        
        $query = @$db->Execute("SELECT * from `_logaholic_users` where username=\"$this->logaholicuser\"") or die("An error occurred:" .$db->ErrorMsg());
        $data = array();
        if ($query->NumRows()!=0) {
            foreach ($query->FetchRow() as $key=>$value) {
                if (!is_numeric($key)) {
                    $data[$key] = $value;
                }
            }
        }
        
        return $data;
    }
    
    function getSiteFromProfilename($profilename) {
        global $db;
        
        $query = @$db->Execute("select confdomain from `_logaholic_Profiles` where profilename=\"$profilename\"") or die("An error occurred:" .$db->ErrorMsg());
        if ($query->NumRows()==0) {
            die ("An error occurred: User $profilename not found");    
        }        
        $q = $query->FetchRow();
        return $q['confdomain'];            
    }
    
    function ListUserProfiles() {
        global $db;
        $profile_list = getProfileList($this->logaholicuser);

        if (!empty($profile_list)) {
            echo "[$profile_list]";
        } else {
            echo '[]';
        }
        return;
    }
	
	    
    /**
    * @desc This function will return the database size of all profiles that belongs to this user
    */	
	function getUserDBSize() {
        global $db;
        $profile_list = getProfileList($this->logaholicuser);		
		if (empty($profile_list)) {
			die("No profiles found for this user"); 
		}
		$size=0;
		$p = explode(",",$profile_list);
		foreach($p as $profile) {
			$dbp = new LogaholicDBProfile($profile);
			$size = $size + $dbp->getProfileDBSize($profile);
		}
		return $size;
    }
    
   
    
}

?>